'use strict';
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initDebug = void 0;
var main_1 = require("electron-log/main");
var electron_1 = require("electron");
var localShortcut = require("electron-localshortcut");
var isMacOS = process.platform === 'darwin';
var devToolsOptions = {
    mode: 'bottom',
};
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function toggleDevTools(win) {
    if (win === void 0) { win = electron_1.BrowserWindow.getFocusedWindow(); }
    if (win) {
        var webContents = win.webContents;
        if (webContents.isDevToolsOpened()) {
            webContents.closeDevTools();
        }
        else {
            webContents.openDevTools(devToolsOptions);
        }
    }
}
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function devTools(win) {
    if (win === void 0) { win = electron_1.BrowserWindow.getFocusedWindow(); }
    if (win) {
        toggleDevTools(win);
    }
}
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function openDevTools(win) {
    if (win === void 0) { win = electron_1.BrowserWindow.getFocusedWindow(); }
    if (win) {
        win.webContents.openDevTools(devToolsOptions);
    }
}
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function refresh(win) {
    if (win === void 0) { win = electron_1.BrowserWindow.getFocusedWindow(); }
    if (win) {
        win.webContents.reloadIgnoringCache();
    }
}
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function inspectElements() {
    var win = electron_1.BrowserWindow.getFocusedWindow();
    var inspect = function () {
        // TODO check
        // win.devToolsWebContents.executeJavaScript('DevToolsAPI.enterInspectElementMode()');
    };
    if (win) {
        if (win.webContents.isDevToolsOpened()) {
            inspect();
        }
        else {
            win.webContents.once('devtools-opened', inspect);
            win.webContents.openDevTools();
        }
    }
}
// const addExtensionIfInstalled = (name, getPath) => {
//   const isExtensionInstalled = nameIN => {
//     return BrowserWindow.getDevToolsExtensions &&
//       {}.hasOwnProperty.call(BrowserWindow.getDevToolsExtensions(), nameIN);
//   };
//
//   try {
//     if (!isExtensionInstalled(name)) {
//       BrowserWindow.addDevToolsExtension(getPath(name));
//     }
//   } catch (_) {
//   }
// };
var initDebug = function (opts, isAddReload) {
    opts = Object.assign(__assign({ enabled: null, showDevTools: true }, devToolsOptions), opts);
    (0, main_1.log)(opts);
    if (opts.enabled === false) {
        return;
    }
    if (opts.devToolsMode !== 'previous') {
        devToolsOptions.mode = opts.devToolsMode;
    }
    electron_1.app.on('browser-window-created', function (event, win) {
        if (opts.showDevTools) {
            win.webContents.once('devtools-opened', function () {
                // Workaround for https://github.com/electron/electron/issues/13095
                setImmediate(function () {
                    win.focus();
                });
            });
            /// Workaround for https://github.com/electron/electron/issues/12438
            win.webContents.once('dom-ready', function () {
                openDevTools(win);
            });
        }
    });
    electron_1.app.on('ready', function () {
        localShortcut.register('CmdOrCtrl+Shift+C', inspectElements);
        localShortcut.register(isMacOS ? 'Cmd+Alt+I' : 'Ctrl+Shift+I', devTools);
        localShortcut.register('F12', devTools);
        if (isAddReload) {
            localShortcut.register('CmdOrCtrl+R', refresh);
            localShortcut.register('F5', refresh);
        }
    });
};
exports.initDebug = initDebug;
//# sourceMappingURL=debug.js.map