"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initFullScreenBlocker = void 0;
var electron_1 = require("electron");
var ipc_events_const_1 = require("./shared-with-frontend/ipc-events.const");
var url_1 = require("url");
var path_1 = require("path");
var initFullScreenBlocker = function (IS_DEV) {
    var isFullScreenWindowOpen = false;
    electron_1.ipcMain.on(ipc_events_const_1.IPC.FULL_SCREEN_BLOCKER, function (ipcEvent, _a) {
        var _b;
        var msg = _a.msg, takeABreakCfg = _a.takeABreakCfg;
        if (isFullScreenWindowOpen) {
            return;
        }
        var isClosable = false;
        var win = new electron_1.BrowserWindow({
            title: msg,
            fullscreen: true,
            alwaysOnTop: true,
            transparent: true,
            skipTaskbar: true,
            frame: false,
        });
        var randomImgUrl = ((_b = takeABreakCfg.motivationalImgs) === null || _b === void 0 ? void 0 : _b.length)
            ? takeABreakCfg.motivationalImgs[Math.floor(Math.random() * takeABreakCfg.motivationalImgs.length)]
            : '';
        win.setAlwaysOnTop(true, 'floating');
        win.setVisibleOnAllWorkspaces(true);
        win.setFullScreenable(false);
        isFullScreenWindowOpen = true;
        win.loadURL((0, url_1.format)({
            pathname: (0, path_1.normalize)((0, path_1.join)(__dirname, IS_DEV
                ? '../src/static/break-reminder-overlay.html'
                : '../dist/static/break-reminder-overlay.html')),
            protocol: 'file:',
            slashes: true,
        }) +
            "#msg=".concat(encodeURI(msg), "&img=").concat(encodeURI(randomImgUrl), "&time=").concat(takeABreakCfg.timedFullScreenBlockerDuration));
        var closeTimeout = setTimeout(function () {
            isClosable = true;
            win.close();
        }, takeABreakCfg.timedFullScreenBlockerDuration || 5000);
        win.on('close', function (evI) {
            if (isClosable) {
                if (closeTimeout) {
                    clearTimeout(closeTimeout);
                }
                isFullScreenWindowOpen = false;
            }
            else {
                evI.preventDefault();
            }
        });
    });
};
exports.initFullScreenBlocker = initFullScreenBlocker;
//# sourceMappingURL=full-screen-blocker.js.map