"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSettings = void 0;
var electron_1 = require("electron");
var ipc_events_const_1 = require("./shared-with-frontend/ipc-events.const");
var main_1 = require("electron-log/main");
var cbs = [];
var getSettings = function (win, cbIN) {
    cbs.push(cbIN);
    win.webContents.send(ipc_events_const_1.IPC.TRANSFER_SETTINGS_REQUESTED);
};
exports.getSettings = getSettings;
electron_1.ipcMain.on(ipc_events_const_1.IPC.TRANSFER_SETTINGS_TO_ELECTRON, getSettingsCb);
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function getSettingsCb(ev, settings) {
    if (cbs.length) {
        cbs.forEach(function (cb) { return cb(settings); });
        cbs = [];
    }
    else {
        // NOTE: can happen, but is unlikely and unlikely to be a problem
        (0, main_1.warn)('getSettingsCb no callbacks left');
    }
}
//# sourceMappingURL=get-settings.js.map