"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initIpcInterfaces = void 0;
// FRONTEND EVENTS
// ---------------
var electron_1 = require("electron");
var ipc_events_const_1 = require("./shared-with-frontend/ipc-events.const");
var lockscreen_1 = require("./lockscreen");
var error_handler_with_frontend_inform_1 = require("./error-handler-with-frontend-inform");
var jira_1 = require("./jira");
var main_1 = require("electron-log/main");
var child_process_1 = require("child_process");
var main_window_1 = require("./main-window");
var various_shared_1 = require("./various-shared");
var simple_store_1 = require("./simple-store");
var backup_1 = require("./backup");
var initIpcInterfaces = function () {
    // HANDLER
    // -------
    electron_1.ipcMain.handle(ipc_events_const_1.IPC.GET_PATH, function (ev, name) {
        return electron_1.app.getPath(name);
    });
    electron_1.ipcMain.handle(ipc_events_const_1.IPC.GET_BACKUP_PATH, function () {
        if (process === null || process === void 0 ? void 0 : process.windowsStore) {
            return backup_1.BACKUP_DIR_WINSTORE;
        }
        else {
            return backup_1.BACKUP_DIR;
        }
    });
    // BACKEND EVENTS
    // --------------
    // ...
    // ON EVENTS
    // ---------
    electron_1.ipcMain.on(ipc_events_const_1.IPC.SHUTDOWN_NOW, various_shared_1.quitApp);
    electron_1.ipcMain.on(ipc_events_const_1.IPC.EXIT, function (ev, exitCode) { return electron_1.app.exit(exitCode); });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.RELAUNCH, function () { return electron_1.app.relaunch(); });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.OPEN_DEV_TOOLS, function () { return (0, main_window_1.getWin)().webContents.openDevTools(); });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.SHOW_EMOJI_PANEL, function () { return electron_1.app.isEmojiPanelSupported() && electron_1.app.showEmojiPanel(); });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.RELOAD_MAIN_WIN, function () { return (0, main_window_1.getWin)().reload(); });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.OPEN_PATH, function (ev, path) { return electron_1.shell.openPath(path); });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.OPEN_EXTERNAL, function (ev, url) { return electron_1.shell.openExternal(url); });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.LOCK_SCREEN, function () {
        if (electron_1.app.isLocked) {
            return;
        }
        try {
            (0, lockscreen_1.lockscreen)();
        }
        catch (e) {
            (0, error_handler_with_frontend_inform_1.errorHandlerWithFrontendInform)(e);
        }
    });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.SET_PROGRESS_BAR, function (ev, _a) {
        var progress = _a.progress, mode = _a.mode;
        var mainWin = (0, main_window_1.getWin)();
        if (mainWin) {
            mainWin.setProgressBar(Math.min(Math.max(progress, 0), 1), { mode: mode });
        }
    });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.FLASH_FRAME, function (ev) {
        var mainWin = (0, main_window_1.getWin)();
        if (mainWin) {
            mainWin.flashFrame(false);
            mainWin.flashFrame(true);
            mainWin.once('focus', function () {
                mainWin.flashFrame(false);
            });
        }
    });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.REGISTER_GLOBAL_SHORTCUTS_EVENT, function (ev, cfg) {
        registerShowAppShortCuts(cfg);
    });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.JIRA_SETUP_IMG_HEADERS, function (ev, _a) {
        var jiraCfg = _a.jiraCfg;
        (0, jira_1.setupRequestHeadersForImages)(jiraCfg);
    });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.JIRA_MAKE_REQUEST_EVENT, function (ev, request) {
        (0, jira_1.sendJiraRequest)(request);
    });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.SHOW_OR_FOCUS, function () {
        var mainWin = (0, main_window_1.getWin)();
        (0, various_shared_1.showOrFocus)(mainWin);
    });
    electron_1.ipcMain.on(ipc_events_const_1.IPC.EXEC, execWithFrontendErrorHandlerInform);
    // eslint-disable-next-line prefer-arrow/prefer-arrow-functions
    function registerShowAppShortCuts(cfg) {
        // unregister all previous
        electron_1.globalShortcut.unregisterAll();
        var GLOBAL_KEY_CFG_KEYS = [
            'globalShowHide',
            'globalToggleTaskStart',
            'globalAddNote',
            'globalAddTask',
        ];
        if (cfg) {
            var mainWin_1 = (0, main_window_1.getWin)();
            Object.keys(cfg)
                .filter(function (key) {
                return GLOBAL_KEY_CFG_KEYS.includes(key);
            })
                .forEach(function (key) {
                var actionFn;
                var shortcut = cfg[key];
                switch (key) {
                    case 'globalShowHide':
                        actionFn = function () {
                            if (mainWin_1.isFocused()) {
                                // we need to blur the window for windows
                                mainWin_1.blur();
                                mainWin_1.hide();
                            }
                            else {
                                (0, various_shared_1.showOrFocus)(mainWin_1);
                            }
                        };
                        break;
                    case 'globalToggleTaskStart':
                        actionFn = function () {
                            mainWin_1.webContents.send(ipc_events_const_1.IPC.TASK_TOGGLE_START);
                        };
                        break;
                    case 'globalAddNote':
                        actionFn = function () {
                            (0, various_shared_1.showOrFocus)(mainWin_1);
                            mainWin_1.webContents.send(ipc_events_const_1.IPC.ADD_NOTE);
                        };
                        break;
                    case 'globalAddTask':
                        actionFn = function () {
                            (0, various_shared_1.showOrFocus)(mainWin_1);
                            // NOTE: delay slightly to make sure app is ready
                            mainWin_1.webContents.send(ipc_events_const_1.IPC.ADD_TASK);
                        };
                        break;
                    default:
                        actionFn = function () { return undefined; };
                }
                if (shortcut && shortcut.length > 0) {
                    try {
                        var ret = electron_1.globalShortcut.register(shortcut, actionFn);
                        if (!ret) {
                            (0, error_handler_with_frontend_inform_1.errorHandlerWithFrontendInform)('Global Shortcut registration failed: ' + shortcut, shortcut);
                        }
                    }
                    catch (e) {
                        (0, error_handler_with_frontend_inform_1.errorHandlerWithFrontendInform)('Global Shortcut registration failed: ' + shortcut, { e: e, shortcut: shortcut });
                    }
                }
            });
        }
    }
};
exports.initIpcInterfaces = initIpcInterfaces;
var COMMAND_MAP_PROP = 'allowedCommands';
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function execWithFrontendErrorHandlerInform(ev, command) {
    return __awaiter(this, void 0, void 0, function () {
        var existingData, allowedCommands, mainWin, res, response, checkboxChecked;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    (0, main_1.log)('trying to run command ' + command);
                    return [4 /*yield*/, (0, simple_store_1.loadSimpleStoreAll)()];
                case 1:
                    existingData = _a.sent();
                    allowedCommands = existingData[COMMAND_MAP_PROP] || [];
                    if (!Array.isArray(allowedCommands)) {
                        throw new Error('allowedCommands is no array ???');
                    }
                    if (!allowedCommands.includes(command)) return [3 /*break*/, 2];
                    (0, child_process_1.exec)(command, function (err) {
                        if (err) {
                            (0, error_handler_with_frontend_inform_1.errorHandlerWithFrontendInform)(err);
                        }
                    });
                    return [3 /*break*/, 6];
                case 2:
                    mainWin = (0, main_window_1.getWin)();
                    return [4 /*yield*/, electron_1.dialog.showMessageBox(mainWin, {
                            type: 'question',
                            buttons: ['Cancel', 'Yes, execute!'],
                            defaultId: 2,
                            title: 'Super Productivity – Exec',
                            message: 'Do you want to execute this command? ONLY confirm if you are sure you know what you are doing!!',
                            detail: command,
                            checkboxLabel: 'Remember my answer',
                            checkboxChecked: true,
                        })];
                case 3:
                    res = _a.sent();
                    response = res.response, checkboxChecked = res.checkboxChecked;
                    if (!(response === 1)) return [3 /*break*/, 6];
                    if (!checkboxChecked) return [3 /*break*/, 5];
                    return [4 /*yield*/, (0, simple_store_1.saveSimpleStore)(COMMAND_MAP_PROP, __spreadArray(__spreadArray([], __read(allowedCommands), false), [command], false))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    (0, child_process_1.exec)(command, function (err) {
                        if (err) {
                            (0, error_handler_with_frontend_inform_1.errorHandlerWithFrontendInform)(err);
                        }
                    });
                    _a.label = 6;
                case 6: return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=ipc-handler.js.map