"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupRequestHeadersForImages = exports.sendJiraRequest = void 0;
var main_window_1 = require("./main-window");
var ipc_events_const_1 = require("./shared-with-frontend/ipc-events.const");
var electron_1 = require("electron");
var node_fetch_1 = require("node-fetch");
var https_1 = require("https");
var main_1 = require("electron-log/main");
var sendJiraRequest = function (_a) {
    var requestId = _a.requestId, requestInit = _a.requestInit, url = _a.url, jiraCfg = _a.jiraCfg;
    var mainWin = (0, main_window_1.getWin)();
    // log('--------------------------------------------------------------------');
    // log(url);
    // log('--------------------------------------------------------------------');
    (0, node_fetch_1.default)(url, __assign(__assign({}, requestInit), (jiraCfg && jiraCfg.isAllowSelfSignedCertificate
        ? {
            agent: new https_1.Agent({
                rejectUnauthorized: false,
            }),
        }
        : {})))
        .then(function (response) { return __awaiter(void 0, void 0, void 0, function () {
        var errText, e2_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!response.ok) return [3 /*break*/, 5];
                    (0, main_1.error)('Jira Error Error Response ELECTRON: ', response);
                    try {
                        (0, main_1.log)(JSON.stringify(response));
                    }
                    catch (e) { }
                    errText = void 0;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, response.text()];
                case 2:
                    errText = _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e2_1 = _a.sent();
                    throw Error(response.statusText);
                case 4: throw Error(errText || response.statusText);
                case 5: return [2 /*return*/, response];
            }
        });
    }); })
        .then(function (res) { return res.text(); })
        .then(function (text) {
        try {
            return text ? JSON.parse(text) : {};
        }
        catch (e) {
            console.error('Error: Cannot parse json');
            console.log('Error: text response', text);
            // throw new Error(e);
            return text;
        }
    })
        .then(function (response) {
        mainWin.webContents.send(ipc_events_const_1.IPC.JIRA_CB_EVENT, {
            response: response,
            requestId: requestId,
        });
    })
        .catch(function (err) {
        mainWin.webContents.send(ipc_events_const_1.IPC.JIRA_CB_EVENT, {
            error: err,
            requestId: requestId,
        });
    });
};
exports.sendJiraRequest = sendJiraRequest;
// TODO simplify and do encoding in frontend service
var setupRequestHeadersForImages = function (jiraCfg) {
    var _a = parseHostAndPort(jiraCfg), host = _a.host, protocol = _a.protocol;
    // TODO export to util fn
    var _b64EncodeUnicode = function (str) {
        return Buffer.from(str || '').toString('base64');
    };
    var encoded = _b64EncodeUnicode("".concat(jiraCfg.userName, ":").concat(jiraCfg.password));
    var filter = {
        urls: ["".concat(protocol, "://").concat(host, "/*")],
    };
    // thankfully only the last attached listener will be used
    // @see: https://electronjs.org/docs/api/web-request
    electron_1.session.defaultSession.webRequest.onBeforeSendHeaders(filter, function (details, callback) {
        if (jiraCfg.usePAT) {
            details.requestHeaders.authorization = "Bearer ".concat(jiraCfg.password);
        }
        else {
            details.requestHeaders.authorization = "Basic ".concat(encoded);
        }
        callback({ requestHeaders: details.requestHeaders });
    });
};
exports.setupRequestHeadersForImages = setupRequestHeadersForImages;
var MATCH_PROTOCOL_REG_EX = /(^[^:]+):\/\//;
var MATCH_PORT_REG_EX = /:\d{2,4}/;
var parseHostAndPort = function (config) {
    var host = config.host;
    var protocol;
    var port;
    if (!host) {
        throw new Error('No host given');
    }
    // parse port from host and remove it
    if (host.match(MATCH_PORT_REG_EX)) {
        var match = MATCH_PORT_REG_EX.exec(host);
        host = host.replace(MATCH_PORT_REG_EX, '');
        port = parseInt(match[0].replace(':', ''), 10);
    }
    // parse protocol from host and remove it
    if (host.match(MATCH_PROTOCOL_REG_EX)) {
        var match = MATCH_PROTOCOL_REG_EX.exec(host);
        host = host
            .replace(MATCH_PROTOCOL_REG_EX, '')
            // remove trailing slash just in case
            .replace(/\/$/, '');
        protocol = match[1];
    }
    else {
        protocol = 'https';
    }
    // log({host, protocol, port});
    return { host: host, protocol: protocol, port: port };
};
//# sourceMappingURL=jira.js.map