"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lockscreen = void 0;
var child_process_1 = require("child_process");
var lockscreen = function (cb) {
    var lockCommands = {
        darwin: '(/System/Library/CoreServices/"Menu Extras"/User.menu/Contents/Resources/CGSession -suspend) || (osascript -e "tell application "System Events" to keystroke "q" using {control down, command down}")',
        win32: 'rundll32.exe user32.dll, LockWorkStation',
        linux: '(hash gnome-screensaver-command 2>/dev/null && gnome-screensaver-command -l) || (hash dm-tool 2>/dev/null && dm-tool lock) || (qdbus org.freedesktop.ScreenSaver /ScreenSaver Lock)',
    };
    var lockCommandToUse = lockCommands[process.platform];
    if (!lockCommandToUse) {
        throw new Error("lockscreen doesn't support your platform (".concat(process.platform, ")"));
    }
    else {
        (0, child_process_1.exec)(lockCommandToUse, function (err, stdout) { return (cb ? cb(err, stdout) : null); });
    }
};
exports.lockscreen = lockscreen;
//# sourceMappingURL=lockscreen.js.map