"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var electron_1 = require("electron");
var various_shared_1 = require("./various-shared");
var start_app_1 = require("./start-app");
var IS_MAC = process.platform === 'darwin';
if (!IS_MAC) {
    // make it a single instance by closing other instances but allow for dev mode
    // because of https://github.com/electron/electron/issues/14094
    var isLockObtained = electron_1.app.requestSingleInstanceLock();
    if (!isLockObtained) {
        console.log('EXITING due to failed single instance lock');
        (0, various_shared_1.quitApp)();
    }
    else {
        console.log('Start app...');
        (0, start_app_1.startApp)();
    }
}
else {
    (0, start_app_1.startApp)();
}
//# sourceMappingURL=main.js.map