"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lazySetInterval = void 0;
// avoids the performance issues caused by normal set interval, when the user
// is not at the computer for some time
var lazySetInterval = function (func, intervalDuration) {
    var lastTimeoutId;
    var interval = function () {
        lastTimeoutId = setTimeout(interval, intervalDuration);
        func.call(null);
    };
    lastTimeoutId = setTimeout(interval, intervalDuration);
    return function () {
        clearTimeout(lastTimeoutId);
    };
};
exports.lazySetInterval = lazySetInterval;
//# sourceMappingURL=lazy-set-interval.js.map