"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.quitApp = quitApp;
exports.showOrFocus = showOrFocus;
var electron_1 = require("electron");
var main_1 = require("electron-log/main");
var main_window_1 = require("./main-window");
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function quitApp() {
    // tslint:disable-next-line
    electron_1.app.isQuiting = true;
    electron_1.app.quit();
}
// eslint-disable-next-line prefer-arrow/prefer-arrow-functions
function showOrFocus(passedWin) {
    // default to main winpc
    var win = passedWin || (0, main_window_1.getWin)();
    // sometimes when starting a second instance we get here although we don't want to
    if (!win) {
        (0, main_1.info)('special case occurred when showOrFocus is called even though, this is a second instance of the app');
        return;
    }
    if (win.isVisible()) {
        win.focus();
    }
    else {
        win.show();
    }
    // focus window afterwards always
    setTimeout(function () {
        win.focus();
    }, 60);
}
//# sourceMappingURL=various-shared.js.map